"use strict";

// ----------------------------- Fcn -----------------------------

// 回傳時間 
function getNowTime() {
  let ServerDate = new Date();
  let yyyy = ServerDate.getFullYear()
  let MM = padLeft(ServerDate.getMonth() + 1, 2);
  let dd = padLeft(ServerDate.getDate(), 2);
  let h = padLeft(ServerDate.getHours(), 2);
  let m = padLeft(ServerDate.getMinutes(), 2);
  let s = padLeft(ServerDate.getSeconds(), 2);

  let dateString = '\n' + yyyy + '-' + MM + '-' + dd + ' ' + h + ':' + m + ':' + s + " ";

  return dateString;
}

function getNowTime_Array() {
  let ServerDate = new Date();
  let yyyy = parseInt(ServerDate.getFullYear());
  let MM = parseInt(ServerDate.getMonth() + 1);
  let dd = parseInt(ServerDate.getDate());
  let h = parseInt(ServerDate.getHours());
  let m = parseInt(ServerDate.getMinutes());
  let s = parseInt(ServerDate.getSeconds());

  let date = [yyyy, MM, dd, h, m, s];

  return date
}

// 取得特定時間
function getDateMMDD() {
  let ServerDate = new Date();
  let MM = (ServerDate.getMonth() + 1 < 10 ? '0' : '') + (ServerDate.getMonth() + 1);
  let dd = (ServerDate.getDate() < 10 ? '0' : '') + ServerDate.getDate();

  let dateString = MM + '' + dd;

  return dateString;
}

// 回傳 Unix 時間戳記
function getUnitTime(Time = 0) {
  return Math.floor(new Date() / 1000) + Time;
}

// 差值法
function Volmap(x, in_min, in_max, out_min, out_max) {
  if (x >= in_max)
    x = in_max;
  if (x <= in_min)
    x = in_min;
  return parseFloat((x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min);
}

// 取小數點 N 位
function formatFloat(num, pos) {
  let size = Math.pow(10, pos);
  return Math.round(num * size) / size;
}

// 生成 QR Code 結構字串
function CreateQRCode_String(RoomID, Data_in) {
  let Random = parseInt(random(255)); // 產生隨機數值
  let Random_Str = padLeft(Random.toString(16), 2);
  let purpose = padLeft((0xc0 ^ Random).toString(16), 2); // 加密數值
  let StartTime = padLeft(getUnitTime().toString(16), 8);
  let EndTime = padLeft((getUnitTime() + 5 * 60 * 60).toString(16), 8);

  let QR_String = GuestQRCode_HEADER + purpose + StartTime +
    EndTime + Random_Str + Data_in + QRCode_TRAILER;

  return QR_String;
}

// 取得隨機 key
function getRanKey() {
  let Key_Str = "";
  for (let i = 0; i < 5; i++) {
    Key_Str += String.fromCharCode(randomChar());
  }
  return Key_Str;
}

// 在左邊補 0
function padLeft(str, lenght) {
  str += "";

  if (str.length >= lenght)
    return str;
  else
    return padLeft("0" + str, lenght);
}

// 隨機取值
function random(Max) {
  return Math.random() * Max;
} // random

// 隨機取字元
function randomChar() {
  let Char = parseInt(random(255));
  while (!isChar(Char)) {
    Char = parseInt(random(255));
  }
  return Char;
} // randomChar

// 隨機取字串
function randomChar_length(length) {
  let Str = "";
  for (let i = 0; i < length; i++) {
    Str += String.fromCharCode(randomChar());
  }
  return Str;
} // randomChar_length

// 隨機取值
function isChar(Num) {
  let Re = false;
  if (Num >= 48 && Num <= 57) {
    Re = true;
  } else if (Num >= 97 && Num <= 122) {
    Re = true;
  }

  return Re;
} // isChar

// 根據 B 矩陣排序 A 矩陣
function getSorted(arr, sortArr) {
  var result = [];
  for (let i = 0; i < arr.length; i++) {
    result[i] = arr[sortArr[i]];
  }
  return result;
}

// 生成資料庫連結，自動加入帳號
function createDbUrl(dbObj) {
  if (dbObj.account === "") {
    return dbObj.url
  }

  let urlSplit = dbObj.url.split("//")
  return `${urlSplit[0]}//${dbObj.account}:${dbObj.password}@${urlSplit[1]}`
}


module.exports = {
  getNowTime,
  getNowTime_Array,
  getDateMMDD,
  getUnitTime,
  Volmap,
  formatFloat,
  CreateQRCode_String,
  getRanKey,
  randomChar_length,
  padLeft,
  random,
  getSorted,

  createDbUrl
};