/*eslint-env jquery */
"use strict";

$(document).ready(function () {
  $(".Date_Input").val(getNowTime());
});


let Name_list = [
  "溝溝狗", "狗勾勾", "狗勾溝", "狗狗溝", "溝狗", "溝勾狗", "狗"
];

// 取得人名清單
get_NameList("winner_list", (Datas) => {
  Name_list = [];
  Name_list.length = 0;

  if (typeof Datas !== 'object') {
    Name_list = JSON.parse(Datas);
  } else {
    Name_list = Datas;
  }
});


// 自動搜尋人名候選
$(document).on("input", ".Name_Input", function (e) {
  let Val = $(this).val();
  let DataListObj = $(this).next("datalist");
  DataListObj.children("option").remove();

  let NArray = Name_list.filter(function (Item, index, array) {
    return Item.toLowerCase().match(Val) !== null;
  });

  // 候選 10 筆
  for (let i = 0; i < 10; i++) {
    if (NArray[i]) {
      DataListObj.append("<option value='" + NArray[i] + "'>");
    }
  }
});
$(document).on("blur", ".Name_Input", function (e) {
  $(this).next("datalist").children("option").remove();
});


// 日期功能
$(document).on("click", ".Date_Btn", function (e) {
  let fcn = $(this).attr("fcn");
  let DateStr = "";

  switch (fcn) {
    case "add":
      {
        let pY = parseInt($(".Date_Input").val().split("-")[0], 10);
        let pM = parseInt($(".Date_Input").val().split("-")[1], 10);
        let pD = parseInt($(".Date_Input").val().split("-")[2], 10);

        let TDate = new Date(pY, pM - 1, pD + 1);
        let Y = TDate.toLocaleDateString().slice(0, 4);
        let M = padLeft(parseInt(TDate.getMonth(), 10) + 1, 2);
        let D = padLeft(TDate.getDate(), 2);

        DateStr = Y + "-" + M + "-" + D;
        break;
      }
    case "less":
      {
        let pY = parseInt($(".Date_Input").val().split("-")[0], 10);
        let pM = parseInt($(".Date_Input").val().split("-")[1], 10);
        let pD = parseInt($(".Date_Input").val().split("-")[2], 10);

        let TDate = new Date(pY, pM - 1, pD - 1);
        let Y = TDate.toLocaleDateString().slice(0, 4);
        let M = padLeft(parseInt(TDate.getMonth(), 10) + 1, 2);
        let D = padLeft(TDate.getDate(), 2);

        DateStr = Y + "-" + M + "-" + D;
        break;
      }
    case "now":
      {
        DateStr = getNowTime();
        break;
      }
  }

  $(".Date_Input").val(DateStr);
});



// 送出資料
$(document).on("click", ".AddData_Btn", function (e) {
  // 檢查欄位
  let Winner = $("#Winner_Input").val();
  let Loser = $("#Loser_Input").val();
  let Point_InputObj = $(".Point_Input");
  let Msg = "";

  if (Winner === "") {
    Msg += "「勝者」為必填欄位<br>";
  }

  if (Loser === "") {
    Msg += "「敗者」為必填欄位<br>";
  }

  let isEmpty = true;
  Point_InputObj.each(function () {
    if ($(this).val() !== "")
      isEmpty = false;
  });

  if (isEmpty) {
    Msg += "「比分」至少要填入一局<br>";
  }

  if (Msg !== "") {
    Show_FloatMsg(Msg);
  } else {
    let Score1 = Point_InputObj.eq(0).val();
    let Score2 = Point_InputObj.eq(1).val();
    let Score3 = Point_InputObj.eq(2).val();
    let Date = $(".Date_Input").val();
    let Remarks = $("#Remarks_Input").val();

    post_Data(Winner, Loser, Score1, Score2, Score3, Date, Remarks, (res) => {
      if (res === "sus") {
        Show_FloatMsg("新增資料成功");

        $("#Winner_Input").val("");
        $("#Loser_Input").val("");
        $("#Remarks_Input").val("");
        Point_InputObj.eq(0).val("");
        Point_InputObj.eq(1).val("");
        Point_InputObj.eq(2).val("");
      } else {
        console.log(res);
        Show_FloatMsg("新增資料發生錯誤");
      }
    });
  }
});


function get_NameList(Type, callback) {
  let settings = {
    "async": true,
    "crossDomain": true,
    "url": LocalServer_URL + "/TTmatch/get_list/" + Type,
    "method": "GET",
    data: {},
    //timeout: 3000
  };

  $.ajax(settings)
    .done(function (res) {
      try {
        let Obj = JSON.parse(res);
        callback(Obj);
      } catch (e) {
        callback(res);
      }
    })
    .fail(function (jqXHR, exception) {
      // Our error logic here
      var msg = '';
      if (jqXHR.status === 0) {
        msg = 'Not connect.\n Verify Network.';
      } else if (jqXHR.status === 404) {
        msg = 'Requested page not found. [404]';
      } else if (jqXHR.status === 500) {
        msg = 'Internal Server Error [500].';
      } else if (exception === 'parsererror') {
        msg = 'Requested JSON parse failed.';
      } else if (exception === 'timeout') {
        msg = 'Time out error.';
      } else if (exception === 'abort') {
        msg = 'Ajax request aborted.';
      } else {
        msg = 'Uncaught Error.\n' + jqXHR.responseText;
      }
      console.log("\nget_NameList : " + msg);
      console.log("settings : ");
      console.log(settings);
    });
}

function post_Data(Winner, Loser, Score1, Score2, Score3, Date, Remarks, callback) {
  let settings = {
    "async": true,
    "url": LocalServer_URL + "/TTmatch/Data",
    "method": "POST",
    "data": {
      Winner,
      Loser,
      Score1,
      Score2,
      Score3,
      Date,
      Remarks
    },
    timeout: 3000
  };

  $.ajax(settings)
    .done(function (res) {
      try {
        let Obj = JSON.parse(res);
        callback(Obj);
      } catch (e) {
        callback(res);
      }
    })
    .fail(function (jqXHR, exception) {
      // Our error logic here
      var msg = '';
      if (jqXHR.status === 0) {
        msg = 'Not connect.\n Verify Network.';
      } else if (jqXHR.status === 404) {
        msg = 'Requested page not found. [404]';
      } else if (jqXHR.status === 500) {
        msg = 'Internal Server Error [500].';
      } else if (exception === 'parsererror') {
        msg = 'Requested JSON parse failed.';
      } else if (exception === 'timeout') {
        msg = 'Time out error.';
      } else if (exception === 'abort') {
        msg = 'Ajax request aborted.';
      } else {
        msg = 'Uncaught Error.\n' + jqXHR.responseText;
      }
      console.log("\npost_Data : " + msg);
      console.log("settings : ");
      console.log(settings);

      Show_FloatMsg("post_Data Err : " + msg);
    });
}