/*eslint-env jquery */
/*globals Vue AjaxFail LocalServer_URL Show_FloatMsg getNowTime*/

"use strict";

update_Account_List();
update_Page_List();
update_Group_List();


var Page_Datas = {
	Ori_Account_List: [],
	Account_List: [{
		_id: "讀取中",
		_rev: "",
		UserName: "",
		Group: "",
		CreationDate: "",
		isChange: false,

		Password: "" // 管理者修改密碼用
	}],
	Ori_Group_List: [],
	Group_List: [{
		_id: "讀取中",
		_rev: "",
		GroupName: "",
		AllowPage: []
	}],
	New_Group_Data: {
		GroupName: "",
		GroupID: ""
	},
	Page_List: [{
		_id: "讀取中",
		_rev: "",
		Info: ""
	}]
};


function update_Account_List() {
	APIMethod({}, "/user/list", "GET", (res) => {
		if (res.resStatus !== "sus") {
			res.Msg && Show_FloatMsg(res.Msg);
			return;
		}

		res.Account_List.forEach((Acc) => {
			Acc.Password = "";
		});

		Page_Datas.Ori_Account_List = JSON.parse(JSON.stringify(res.Account_List));
		Page_Datas.Account_List = JSON.parse(JSON.stringify(res.Account_List));
	});
}

function update_Page_List() {
	APIMethod({}, "/admin/page/list", "GET", (res) => {
		if (res.resStatus !== "sus") {
			res.Msg && Show_FloatMsg(res.Msg);
			return;
		}

		let Page_List = res.rows.map((Item) => {
			return Item.doc;
		});
		Page_Datas.Page_List = Page_List;
	});
}

function update_Group_List() {
	APIMethod({}, "/admin/group/list", "GET", (res) => {
		if (res.resStatus !== "sus") {
			res.Msg && Show_FloatMsg(res.Msg);
			return;
		}

		let Group_List = res.rows.map((Item) => {
			return Item.doc;
		});

		Page_Datas.Ori_Group_List = JSON.parse(JSON.stringify(Group_List));
		Page_Datas.Group_List = JSON.parse(JSON.stringify(Group_List));
	});
}

function post_New_Group(Group_Data) {
	APIMethod(Group_Data, "/admin/group", "POST", (res) => {
		res.Msg && Show_FloatMsg(res.Msg);

		update_Group_List();
	});
}

new Vue({
	el: ".Page",
	data: Page_Datas,
	methods: {
		Click_Event: function (Event) {
			switch_Click_Event(Event);
		},
		Data_isChanges: function (Ori_Data, Edit_Data) {
			Ori_Data.isChange = false;
			Edit_Data.isChange = false;

			if (Ori_Data._id === "Test") {
				console.log(Ori_Data._id);
				console.log(Ori_Data);
				console.log(Edit_Data);
			}

			let OriStr = JSON.stringify(Ori_Data);
			let EditStr = JSON.stringify(Edit_Data);

			if (OriStr === EditStr)
				return Edit_Data.isChange = false;

			return Edit_Data.isChange = true;
		},
		Array_isChanges: function (Ori_Array, Edit_Array, Obj) {
			let sort_Ori_Array = Ori_Array.sort().toString();
			let sort_Edit_Array = Edit_Array.sort().toString();

			if (sort_Ori_Array === sort_Edit_Array)
				return Obj.isChange = false;

			return Obj.isChange = true;
		},
		Submit_Edit_Group: function (Group_Data) {
			delete Group_Data.isChange;

			APIMethod(Group_Data, "/admin/group", "PUT", (res) => {
				res.Msg && Show_FloatMsg(res.Msg);

				update_Group_List();
			});
		},
		Submit_Edit_Account: function (Account_Data) {
			delete Account_Data.isChange;

			APIMethod(Account_Data, "/user_data", "PUT", (res) => {
				res.Msg && Show_FloatMsg(res.Msg);

				update_Account_List();
			});
		},
		delete_Account: function (Account_Data) {
			let key = getRanKey();
			let input = prompt("確認刪除帳號「" + Account_Data._id + "」請輸入 " + key, "")

			if (!input) {
				return;
			} else if (input !== key) {
				return confirm("輸入錯誤");
			}

			delete Account_Data.isChange;

			APIMethod(Account_Data, "/user_data", "DELETE", (res) => {
				res.Msg && Show_FloatMsg(res.Msg);

				update_Account_List();
			});
		}
	}
});

// ---------------------------------------- function  ----------------------------------------

function APIMethod(data, URL, Method, callback) {
	let settings = {
		"async": true,
		"crossDomain": true,
		"url": LocalServer_URL + URL,
		"method": Method,
		data: data,
		timeout: 5000
	};

	$.ajax(settings).done(function (res) {
		try {
			let Obj = JSON.parse(res);
			callback(Obj);
		} catch (e) {
			callback(res);
		}
	}).fail(function (jqXHR, exception) {
		callback(exception);
		console.log("err : " + URL);

		res.Msg && Show_FloatMsg(res.Msg);

		AjaxFail("\n" + Method + " " + URL + " : ", settings, jqXHR, exception);
	});
}

function switch_Click_Event(Event) {
	switch (Event) {
		case "Add_Account":
			{
				let UserName = $("#UserName").val();
				let Group = $("#Group").val();
				let Account = $("#Account").val();
				let Password = $("#Password").val();
				let CheckPassword = $("#CheckPassword").val();

				/*console.log("UserName : " + UserName);
				console.log("Group    : " + Group);
				console.log("Account  : " + Account);*/

				if (!UserName)
					return Show_FloatMsg("請輸入姓名");

				if (!Account)
					return Show_FloatMsg("請輸入帳號");

				if (!Password && !CheckPassword)
					return Show_FloatMsg("請輸入密碼");

				if (Password !== CheckPassword)
					return Show_FloatMsg("密碼不一致");

				let Obj = {
					_id: Account,
					UserName,
					Group,
					Password,
					Date: getNowTime(true)
				};

				APIMethod(Obj, "/user", "POST", (res) => {
					Show_FloatMsg(res.Msg);
					update_Account_List();
				});
				break;
			}

		case "Add_Group":
			{
				let Group_Data = {
					_id: Page_Datas.New_Group_Data.GroupID,
					GroupName: Page_Datas.New_Group_Data.GroupName,
					AllowPage: ["ListPage"]
				};

				Page_Datas.New_Group_Data.GroupID = "";
				Page_Datas.New_Group_Data.GroupName = "";

				post_New_Group(Group_Data);
				break;
			}

	} // switch
}