/*eslint-env jquery */
/*globals Vue AjaxFail*/
"use strict";

const defind_MIME = {
  JSON: "application/json",
  CSV: "text/csv"
}

var TTmatch_Datas = {
  Enable_Limit: true,
  isLoading: false,
  Field_isExport: [true, true, true, true, true, true, true],
  Field_Name: ["勝者", "敗者", "比分 1", "比分 2", "比分 3", "日期", "備註"],
  All_Datas: [{
    "Winner": "勝者名",
    "Loser": "敗者名",
    "Score1": 1,
    "Score2": 1,
    "Score3": 1,
    "Date": "2018/10/6",
    "Remarks": "備註備註備註備註",
    "key": "5f15b4e654",
    "rev": "1-f45weag45ra4g5rea4g56eah4"
  }, {
    "Winner": "勝者名",
    "Loser": "敗者名",
    "Score1": 1,
    "Score2": 1,
    "Score3": 1,
    "Date": "2018/10/6",
    "Remarks": "備註備註備註備註",
    "key": "5f15b4e654",
    "rev": "1-f45weag45ra4g5rea4g56eah4"
  }],
  Preview_Datas: [{
    "Winner": "勝者名",
    "Loser": "敗者名",
    "Score1": 1,
    "Score2": 1,
    "Score3": 1,
    "Date": "2018/10/6",
    "Remarks": "備註備註備註備註",
    "key": "5f15b4e654",
    "rev": "1-f45weag45ra4g5rea4g56eah4"
  }]
};

$(document).ready(function () {
  get_log($("#Amount_Input").val(), 0);
});

let Name_list = [
  "溝溝狗", "狗勾勾", "狗勾溝", "狗狗溝", "溝狗", "溝勾狗", "狗"
];

// ------------------------- 取得人名清單 ------------------------- 
get_NameList("winner_list", (Datas) => {
  Name_list = [];
  Name_list.length = 0;

  if (typeof Datas !== 'object') {
    Name_list = JSON.parse(Datas);
  } else {
    Name_list = Datas;
  }
});

// ------------------------- 自動搜尋人名候選 ------------------------- 
$(document).on("input", ".Name_Input", function (e) {
  let Val = $(this).val();
  let DataListObj = $(this).next("datalist");
  DataListObj.children("option").remove();

  let NArray = Name_list.filter(function (Item, index, array) {
    return Item.toLowerCase().match(Val) !== null;
  });

  // 候選 10 筆
  for (let i = 0; i < 10; i++) {
    if (NArray[i]) {
      DataListObj.append("<option value='" + NArray[i] + "'>");
    }
  }
});

// ------------------------- 取得資料 ------------------------- 
$(document).on("blur", ".Name_Input", function (e) {
  $(this).next("datalist").children("option").remove();
});

$(document).on("change", ".Change_Event", function () {
  if (TTmatch_Datas.Enable_Limit) {
    get_log($("#Amount_Input").val(), 0);
    return;
  }

  get_log_info((res) => {
    get_log(res.doc_count, 0);
  });
}).on("blur", ".Blur_Event", function () {
  if (TTmatch_Datas.Enable_Limit) {
    get_log($("#Amount_Input").val(), 0);
    return;
  }

  get_log_info((res) => {
    get_log(res.doc_count, 0);
  });
});

// ------------------------- 滾動到底時，更新資料 ------------------------- 
let debounce;
$("body").scroll(function () {
  let Obj = $(this);
  let ScrollHeight = Obj.prop("scrollHeight") - Obj.innerHeight();
  let NowScrollBar = Obj.prop("scrollTop");

  clearTimeout(debounce)
  if (NowScrollBar > ScrollHeight * 0.9) {
    debounce = setTimeout(() => {
      update_Preview_Datas();
    }, 200)
  }
});

// ------------------------- 下載資料 ------------------------- 
$(document).on("click", ".Download_Btn", function (e) {
  let ExportDatas = [];
  let Data_Key_Array = Object.keys(TTmatch_Datas.All_Datas[0]); // key 清單

  // 處理資料
  TTmatch_Datas.All_Datas.forEach((Item) => {
    let DataObj = {};

    for (let i = 0; i < Data_Key_Array.length; i++) {
      if (!TTmatch_Datas.Field_isExport[i]) // 是否輸出
        continue;

      let Val = process_DataFormat(i, Item[Data_Key_Array[i]]);
      DataObj[TTmatch_Datas.Field_Name[i]] = Val;
    } // for

    ExportDatas.push(DataObj);
  });

  let File_Format = $("#File_Format_select").val();
  let OutputData = process_FileFormat(File_Format, ExportDatas);

  Download_Data(defind_MIME[File_Format], OutputData[0], OutputData[1]);
});

function process_DataFormat(Index_in, OriData) {
  switch (Index_in) {
    case 5:
      { // 日期
        if ($("#Date_Format_select").val() === "String") {
          return OriData;
        }

        return OriData.split("/");
      }
    default:
      {
        return OriData;
      }
  }
}

function process_FileFormat(Type, OriData) {
  switch (Type) {
    case "ORI":
      {
        let outDatas = JSON.parse(JSON.stringify(TTmatch_Datas.All_Datas));
        outDatas.forEach((data, index) => {
          delete outDatas[index]["_rev"];
        });
        return [JSON.stringify(outDatas), $("#FileName_Input").val() + ".json"];
      }
    case "JSON":
      {
        return [JSON.stringify(OriData), $("#FileName_Input").val()];
      }
    case "CSV":
      {
        return [json2csv(OriData), $("#FileName_Input").val() + ".csv"];
      }
  }
}

function Download_Data(MIME, Data, name) {
  var link = document.createElement("a");
  link.download = name;

  // UTF-8 BOM, Ref : https://stackoverflow.com/questions/19492846/javascript-to-csv-export-encoding-issue
  link.href = "data:" + MIME + ";charset=utf-8,%EF%BB%BF" + Data;
  link.click();
}

new Vue({
  el: ".Page",
  data: TTmatch_Datas,
  methods: {
    PATCH_Data: function (Index) {
      APIMethod_Data(this.Data[Index], "PATCH", (res) => {
        if (res === "sus") {
          Show_FloatMsg("修改資料成功");
        } else {
          console.log(res);
          Show_FloatMsg("修改資料發生錯誤");
        }
      });
    },
    DELETE_Data: function (Index) {
      let inputText = prompt("您確認要刪除此紀錄？確認刪除請輸入「delete」 ", "");

      if (inputText === "delete") {
        APIMethod_Data(this.Data[Index], "DELETE", (res) => {
          if (res === "sus") {
            Show_FloatMsg("刪除資料成功");
          } else {
            console.log(res);
            Show_FloatMsg("刪除資料發生錯誤");
          }
        });
      } else if (inputText !== null) {
        Show_FloatMsg("刪除訊息輸入錯誤");
      }

    }
  }
});

function update_Preview_Datas() {
  let OriLength = TTmatch_Datas.Preview_Datas.length;

  TTmatch_Datas.Preview_Datas = [];
  TTmatch_Datas.Preview_Datas.length = 0;

  if (OriLength + 10 >= TTmatch_Datas.All_Datas.length) {
    TTmatch_Datas.All_Datas.forEach((Item) => {
      TTmatch_Datas.Preview_Datas.push(Item);
    });
  } else {
    for (let i = 0; i < OriLength + 10; i++) {
      TTmatch_Datas.Preview_Datas.push(TTmatch_Datas.All_Datas[i]);
    }
  }
}

function get_log(limit, skip) {
  let Winner_Input_Val = $("#Winner_Input").val();
  let Loser_Input_Val = $("#Loser_Input").val();
  let StartDate_Val = $("#SDate_Input").val();
  let EndDate_Val = $("#EDate_Input").val();
  let Both_Checkbox_Val = $("#Both_Checkbox").prop("checked") ? "true" : "false";

  if (parseInt(limit, 10) < 0) {
    Show_FloatMsg("資料數量無效");
    return;
  }

	/*console.log("Winner_Input_Val : " + Winner_Input_Val);
	console.log("Loser_Input_Val  : " + Loser_Input_Val);
	console.log("StartDate_Val    : " + StartDate_Val);
	console.log("EndDate_Val      : " + EndDate_Val);
	console.log("limit            : " + limit);
	console.log("skip             : " + skip);*/

  TTmatch_Datas.isLoading = true;
  TTmatch_Datas.Preview_Datas.length = 0;
  TTmatch_Datas.Preview_Datas = [];

  TTmatch_Datas.All_Datas.length = 0;
  TTmatch_Datas.All_Datas = [];

  query_log(Winner_Input_Val, Loser_Input_Val, Both_Checkbox_Val, StartDate_Val, EndDate_Val, limit, skip, function (Datas) {
		/*console.log("query_sys_event_log : ");
		console.log(Datas);*/

    TTmatch_Datas.isLoading = false;
    if (skip === 0) {
      TTmatch_Datas.All_Datas.length = 0;
      TTmatch_Datas.All_Datas = [];
    }


    Datas.docs.forEach(Item => {
      let Obj = {
        "Winner": Item.winner,
        "Loser": Item.loser,
        "Score1": Item.Score1,
        "Score2": Item.Score2,
        "Score3": Item.Score3,
        "Date": padLeft(Item.Date[0], 4) + "/" + padLeft(Item.Date[1], 2) + "/" + padLeft(Item.Date[2], 2),
        "Remarks": Item.Remarks,
        _id: Item._id,
        _rev: Item._rev
      };
      TTmatch_Datas.All_Datas.push(Obj);
    });

    update_Preview_Datas();
  });
}


function query_log(Winner_in, Loser_in, Both_Checkbox_Val, SDate_in, EDate_in, limit_in, skip_in, callback) {
  let settings = {
    "async": true,
    "crossDomain": true,
    "url": LocalServer_URL + "/TTmatch/query_log",
    "method": "GET",
    data: {},
    timeout: 10000
  };

  if (Winner_in)
    settings.data.Winner = Winner_in;

  if (Loser_in)
    settings.data.Loser = Loser_in;

  settings.data.Both = Both_Checkbox_Val;

  if (SDate_in)
    settings.data.StartDate = SDate_in;

  if (EDate_in)
    settings.data.EndDate = EDate_in;

  if (limit_in)
    settings.data.limit = limit_in;

  if (skip_in)
    settings.data.skip = skip_in;

  //console.log(settings.data);

  $.ajax(settings).done(function (res) {
    try {
      let Obj = JSON.parse(res);
      callback(Obj);
    } catch (e) {
      callback(res);
    }
  }).fail(function (jqXHR, exception) {
    callback(exception);
    AjaxFail("\nquery_log : ", settings, jqXHR, exception);
  });
}

function get_log_info(callback) {
  let settings = {
    "async": true,
    "crossDomain": true,
    "url": LocalServer_URL + "/TTmatch/query_log/info",
    "method": "GET",
    data: {},
    timeout: 3000
  };

  $.ajax(settings).done(function (res) {
    try {
      let Obj = JSON.parse(res);
      callback(Obj);
    } catch (e) {
      callback(res);
    }
  }).fail(function (jqXHR, exception) {
    callback(exception);
    AjaxFail("\nget_log_info : ", settings, jqXHR, exception);
  });
}



function APIMethod_Data(data, Method, callback) {
  let settings = {
    "async": true,
    "crossDomain": true,
    "url": LocalServer_URL + "/TTmatch/Data",
    "method": Method,
    data: data,
    timeout: 3000
  };

  $.ajax(settings).done(function (res) {
    try {
      let Obj = JSON.parse(res);
      callback(Obj);
    } catch (e) {
      callback(res);
    }
  }).fail(function (jqXHR, exception) {
    callback(exception);
    AjaxFail("\nAPIMethod_Data : ", settings, jqXHR, exception);
  });
}