/*eslint-env jquery */
/*globals Vue */
"use strict";

var TTmatch_Datas = {
  Data: [{
    "Winner": "勝者名",
    "Loser": "敗者名",
    "Score1": 1,
    "Score2": 1,
    "Score3": 1,
    "Date": "2018/10/6",
    "Remarks": "備註備註備註備註",
    "key": "5f15b4e654",
    "rev": "1-f45weag45ra4g5rea4g56eah4"
  }, {
    "Winner": "勝者名",
    "Loser": "敗者名",
    "Score1": 1,
    "Score2": 1,
    "Score3": 1,
    "Date": "2018/10/6",
    "Remarks": "備註備註備註備註",
    "key": "5f15b4e654",
    "rev": "1-f45weag45ra4g5rea4g56eah4"
  }]
};

$(document).ready(function () {
  get_log(10, 0);
});

let Name_list = [
  "溝溝狗", "狗勾勾", "狗勾溝", "狗狗溝", "溝狗", "溝勾狗", "狗"
];

// 取得人名清單
get_NameList("winner_list", (Datas) => {
  Name_list = [];
  Name_list.length = 0;

  if (typeof Datas !== 'object') {
    Name_list = JSON.parse(Datas);
  } else {
    Name_list = Datas;
  }
});

// 自動搜尋人名候選
$(document).on("input", ".Name_Input", function (e) {
  let Val = $(this).val();
  let DataListObj = $(this).next("datalist");
  DataListObj.children("option").remove();

  let NArray = Name_list.filter(function (Item, index, array) {
    return Item.toLowerCase().match(Val) !== null;
  });

  // 候選 10 筆
  for (let i = 0; i < 10; i++) {
    if (NArray[i]) {
      DataListObj.append("<option value='" + NArray[i] + "'>");
    }
  }
});
$(document).on("blur", ".Name_Input", function (e) {
  $(this).next("datalist").children("option").remove();
});

$(document).on("change", ".Change_Event", function () {
  get_log(10, 0);
});
$(document).on("blur", ".Blur_Event", function () {
  get_log(10, 0);
});

let debounce;
$("body").scroll(function () {
  let Obj = $(this);
  let ScrollHeight = Obj.prop("scrollHeight") - Obj.innerHeight();
  let NowScrollBar = Obj.prop("scrollTop");

  clearTimeout(debounce)
  if (NowScrollBar > ScrollHeight * 0.9) {
    debounce = setTimeout(() => {
      get_log(TTmatch_Datas.Data.length + 10, 0);
    }, 200)
  }
});


new Vue({
  el: ".List_Area",
  data: TTmatch_Datas,
  methods: {
    PATCH_Data: function (Index) {
      APIMethod_Data(this.Data[Index], "PATCH", (res) => {
        if (res === "sus") {
          Show_FloatMsg("修改資料成功");
          get_log(10, 0);
        } else {
          console.log(res);
          Show_FloatMsg("修改資料發生錯誤");
        }
      });
    },
    DELETE_Data: function (Index) {
      let inputText = prompt("您確認要刪除此紀錄？確認刪除請輸入「delete」 ", "");

      if (inputText === "delete") {
        APIMethod_Data(this.Data[Index], "DELETE", (res) => {
          if (res === "sus") {
            Show_FloatMsg("刪除資料成功");
            get_log(10, 0);
          } else {
            console.log(res);
            Show_FloatMsg("刪除資料發生錯誤");
          }
        });
      } else if (inputText !== null) {
        Show_FloatMsg("刪除訊息輸入錯誤");
      }

    }
  }
});


function get_log(limit, skip) {
  let Winner_Input_Val = $("#Winner_Input").val();
  let Loser_Input_Val = $("#Loser_Input").val();
  let StartDate_Val = $("#SDate_Input").val();
  let EndDate_Val = $("#EDate_Input").val();
  let Both_Checkbox_Val = $("#Both_Checkbox").prop("checked") ? "true" : "false";

	/*console.log("Winner_Input_Val : " + Winner_Input_Val);
	console.log("Loser_Input_Val  : " + Loser_Input_Val);
	console.log("StartDate_Val    : " + StartDate_Val);
	console.log("EndDate_Val      : " + EndDate_Val);
	console.log("limit            : " + limit);
	console.log("skip             : " + skip);*/

  query_log(Winner_Input_Val, Loser_Input_Val, Both_Checkbox_Val, StartDate_Val, EndDate_Val, limit, skip, function (Datas) {
		/*console.log("query_sys_event_log : ");
		console.log(Datas);*/

    if (skip === 0) {
      TTmatch_Datas.Data.length = 0;
      TTmatch_Datas.Data = [];
    }


    Datas.docs.forEach(Item => {
      let Obj = {
        "Winner": Item.winner,
        "Loser": Item.loser,
        "Score1": Item.Score1,
        "Score2": Item.Score2,
        "Score3": Item.Score3,
        "Date": padLeft(Item.Date[0], 4) + "/" + padLeft(Item.Date[1], 2) + "/" + padLeft(Item.Date[2], 2),
        "Remarks": Item.Remarks,
        _id: Item._id,
        _rev: Item._rev
      };
      TTmatch_Datas.Data.push(Obj);
    });
  });
}


function query_log(Winner_in, Loser_in, Both_Checkbox_Val, SDate_in, EDate_in, limit_in, skip_in, callback) {
  let settings = {
    "async": true,
    "crossDomain": true,
    "url": LocalServer_URL + "/TTmatch/query_log",
    "method": "GET",
    data: {},
    timeout: 10000
  };

  if (Winner_in)
    settings.data.Winner = Winner_in;

  if (Loser_in)
    settings.data.Loser = Loser_in;

  settings.data.Both = Both_Checkbox_Val;

  if (SDate_in)
    settings.data.StartDate = SDate_in;

  if (EDate_in)
    settings.data.EndDate = EDate_in;

  if (limit_in)
    settings.data.limit = limit_in;

  if (skip_in)
    settings.data.skip = skip_in;

  //console.log(settings.data);

  $.ajax(settings).done(function (res) {
    try {
      let Obj = JSON.parse(res);
      callback(Obj);
    } catch (e) {
      callback(res);
    }
  }).fail(function (jqXHR, exception) {
    callback(exception);
    AjaxFail("\nquery_log : ", settings, jqXHR, exception);
  });
}



function APIMethod_Data(data, Method, callback) {
  let settings = {
    "async": true,
    "crossDomain": true,
    "url": LocalServer_URL + "/TTmatch/Data",
    "method": Method,
    data: data,
    timeout: 3000
  };

  $.ajax(settings).done(function (res) {
    try {
      let Obj = JSON.parse(res);
      callback(Obj);
    } catch (e) {
      callback(res);
    }
  }).fail(function (jqXHR, exception) {
    callback(exception);
    AjaxFail("\nAPIMethod_Data : ", settings, jqXHR, exception);
  });
}
