/*eslint-env jquery */
/*globals Show_FloatMsg */
"use strict";

$(document).on("click", ".Login_Btn", function() {	
	post_Login((res) => {
		if (res.resStatus === "err") {
			Show_FloatMsg(res.Msg);
		} else {
			window.location.href = res.url;
		}
	});
});

$('body').keydown(function(event) {
	if (event.keyCode === 13) { // enter
		post_Login((res) => {
			if (res.resStatus === "err") {
				Show_FloatMsg(res.Msg);
			} else {
				window.location.href = res.url;
			}
		});
	}
});


function post_Login(callback) {
	let Account = $("#Account_Input").val();
	let Password = $("#Password_Input").val();

	if (Account === "" || Password === "") {
		Show_FloatMsg("請填入帳號密碼");
		return;
	}

	let settings = {
		"async": true,
		"url": "/login",
		"method": "POST",
		"data": {
			Account,
			Password
		},
		timeout: 3000
	};

	$.ajax(settings).done(function(res) {
		if (typeof res === 'string')
			callback(JSON.parse(res));

		callback(res);
	}).fail(function(jqXHR, exception) {
		var msg = '';
		if (jqXHR.status === 0) {
			msg = 'Not connect.\n Verify Network.';
		} else if (jqXHR.status === 404) {
			msg = 'Requested page not found. [404]';
		} else if (jqXHR.status === 500) {
			msg = 'Internal Server Error [500].';
		} else if (exception === 'parsererror') {
			msg = 'Requested JSON parse failed.';
		} else if (exception === 'timeout') {
			msg = 'Time out error.';
		} else if (exception === 'abort') {
			msg = 'Ajax request aborted.';
		} else {
			msg = 'Uncaught Error.\n' + jqXHR.responseText;
		}
		console.log("\npost_Login : " + msg);
		console.log("settings : ");
		console.log(settings);

		Show_FloatMsg("post_Login Err : " + msg);
	});
}