"use strict";

var Screen_Datas = {
  nowPage: "AddPage",
  Account: {
    UserName: "使用者",
    Group: "admin",
    _id: "user",
    AllowPage: [
      "AddPage", "AdminPage", "AnalysisPage", "EditPage", "ListPage", "ExportPage", "UserPage"
    ]
  }
};

new Vue({
  el: ".V_FullHight_Layout",
  data: Screen_Datas,
  created: function () {
    this.Account.AllowPage = [];
    this.Account.AllowPage.length = 0;

    // 取得帳號資料
    APIMethod("user", "GET", (res) => {
      if (res.url) {
        window.location.href = res.url; return;
      }

      if (window.localStorage.pPageID)
        this.nowPage = window.localStorage.pPageID;

      this.Account = res.Account;

      // 若上次頁面為沒有權限瀏覽的頁面
      if (this.Account.AllowPage.indexOf(this.nowPage) < 0)
        this.nowPage = this.Account.AllowPage[0];

      window.localStorage.pPageID = this.nowPage;
    });

  },
  methods: {
    logout: function () {
      APIMethod("logout", "GET", (res) => {
        if (res.resStatus === "err") {
          Show_FloatMsg(res.Msg); return;
        }

        window.location.href = res.url;
      });
    },
    set_page(pageID) {
      if (this.nowPage === pageID) return

      this.nowPage = pageID
      window.localStorage.pPageID = pageID;

      /*APIMethod("user", "GET", (res) => {
        if (res.url) {
          window.location.href = res.url; return;
        }

        this.nowPage = pageID
        window.localStorage.pPageID = pageID;
      });//*/
    },
    menuBtn_status(ID_array) {
      let val = {
        enable: false, class: ""
      }

      val.enable = ID_array.some((page) => {
        return this.Account.AllowPage.indexOf(page) >= 0
      })

      ID_array.some((page) => {
        return this.nowPage === page
      }) && (val.class = "active")

      return val
    }
  }
});

// ---------------------------------------- function  ----------------------------------------


function APIMethod(URL, Method, callback) {
  let settings = {
    "async": true,
    "url": "/" + URL,
    "method": Method,
    "data": {},
    //timeout: 3000
  };

  $.ajax(settings).done(function (res) {
    try {
      let Obj = JSON.parse(res);
      callback(Obj);
    } catch (e) {
      callback(res);
    }
  }).fail(function (jqXHR, exception) {
    let msg = AjaxFail("\n" + Method + " " + URL + " : ", settings, jqXHR, exception);
    Show_FloatMsg("Logout Err : " + msg);
  });
}